<?php

defined('_JEXEC') or die;

jimport('joomla.application.component.model');

class AlfabankPaymentModelOrderv2 extends JModelLegacy {
    
    public function __construct($config = array()) {
        require_once(dirname(__FILE__) . '/../orderv2.php');
        parent::__construct($config);
    }
    
    public static function newSoap($url, $login, $password) {
        return new orderv2(null, array(
                                        'location' => $url,
                                        'uri'      => 'http://www.sirena-travel.ru',
                                        'login'    => $login,
                                        'password' => $password,
                                        'trace'    => 0,
                                        'features' => SOAP_SINGLE_ELEMENT_ARRAYS));
    }

    // подготавливаем данные заказа для отправки
    public static function prepareOrder($shopId, $orderId, $orderAmount, $userName, $okUrl, $faultUrl, $tax, $typename, $name) {
        $request = new register();
        $order = new OrderID(); 
        $order->shop_id = $shopId;
        $order->number = $orderId;
        $cost = new Amount();
        $cost->amount = $orderAmount;
        $cost->currency = 'RUB';

        $description = new OrderInfo();
        $description->paytype = 'card';

        if (!empty($tax)) {
            $arItems = array();
            $itemCost = new Amount();
            $itemCost->amount = $orderAmount;
            $itemCost->currency = 'RUB';
            
            $taxVal = $orderAmount - $orderAmount / (1 + $tax / 100);
            $itemTaxes = array(new SoapVar("<tax type='vat'><percentage>".$tax."</percentage><amount><currency>".'RUB'."</currency><amount>".round($taxVal, 2)."</amount></amount></tax>", XSD_ANYXML),);

            $item = new OrderItem();
            $item->number = $orderId;
            $item->amount = $itemCost;
            if (!empty($typename)) {
                $item->typename = $typename;
            } else {
                $item->typename = 'goods';
            }
            $item->quantity = 1;
            if (!empty($name)) {
                $item->name = $name;
            } else {
                $item->name = 'goods';
            }
            $item->taxes = new SoapVar($itemTaxes, SOAP_ENC_OBJECT);

            $arItems[] = new SoapVar($item, SOAP_ENC_OBJECT, null, null, 'OrderItem');
        }
        $description->sales = new SoapVar($arItems, SOAP_ENC_OBJECT);

        $customer = new CustomerInfo();
        $customer->name = $userName;
        $language = new PostEntry();
        $language->name = 'Language';
        $language->value = 'ru';
        $returnUrlOk = new PostEntry();
        $returnUrlOk->name = 'ReturnURLOk';
        $returnUrlOk->value = $okUrl;
        $returnUrlFault = new PostEntry();
        $returnUrlFault->name = 'ReturnURLFault';
        $returnUrlFault->value = $faultUrl;
        $cardtype = new PostEntry();
        $cardtype->name = 'ChoosenCardType';
        $cardtype->value = 'VI';
        $request->order = $order;
        $request->cost = $cost;
        $request->customer = $customer;
        $request->description = $description;

        $postdata = new SoapVar(array(
                                        new SoapVar($language, SOAP_ENC_OBJECT, null, null, 'PostEntry'),
                                        new SoapVar($cardtype, SOAP_ENC_OBJECT, null, null, 'PostEntry'),
                                        new SoapVar($returnUrlOk, SOAP_ENC_OBJECT, null, null, 'PostEntry'),
                                        new SoapVar($returnUrlFault, SOAP_ENC_OBJECT, null, null, 'PostEntry'),
                                ), SOAP_ENC_OBJECT);

        $request->postdata = $postdata;

        return $request;
    }

    public static function getOrderStatus($shopId, $orderId) {
        $status = new get_status();
        $order = new OrderID();
        $order->shop_id = $shopId;
        $order->number = $orderId;
        $status->order = $order;
        return $status;
    }

}